﻿using System.Collections.Generic;
using System.IO;
using System.Web.Mvc;

namespace AngularAspNetMvc.Web.Controllers
{
    public class TestController : Controller
    {
        public ActionResult Index(string fileName)
        {
            var data = new List<string>();
            var path = Server.MapPath("~/appSpec");
            var testScriptsFolder = new DirectoryInfo(path);
            var scripts = testScriptsFolder.GetFiles("*.spec.js", SearchOption.AllDirectories);
            var root = this.HttpContext.Request.Path.ToUpper().Replace("/TEST", "");
            foreach (var fileInfo in scripts)
            {
                if (fileInfo.DirectoryName != null &&
                    (string.IsNullOrEmpty(fileName) || 
                        fileInfo.Name.ToUpper().Contains(fileName.ToUpper())))
                {
                    data.Add(root + @"/appSpec" + fileInfo.DirectoryName.Replace(path, "")
                        .Replace(@"\", @"/") + @"/" + fileInfo.Name);
                }
            }
            return View("Test", "_TestLayout", data);
        }
    }
}
