/// <reference path="../scripts/typings/angularjs/angular-route.d.ts" />
var app;
(function (app) {
    var AppUtils = (function () {
        function AppUtils() {
        }
        AppUtils.createViewUrl = function (fragmnt, globals) {
            return globals.baseUrl + fragmnt + "?v=" + globals.version;
        };
        return AppUtils;
    })();

    angular.module("app", [
        "ngRoute",
        "app.globalsModule",
        "app.directives.Common",
        "app.directives.validation",
        "app.home.controllers",
        "app.contacts.contactsController",
        "app.contacts.contactsEditController",
        "app.contacts.contactsTypesController",
        "app.contacts.contactsTypesEditController",
        "app.home.services",
        "app.reports.reportsService",
        "app.reports.reportsController",
        "app.reports.reportsViewController"
    ]).config([
        "$routeProvider", "$windowProvider", "globalsServiceProvider", "app.home.menuServiceProvider",
        function ($routeProvider, $window, globalsServiceProvider, menuServiceProvider) {
            var globals = globalsServiceProvider.$get();
            var menuService = menuServiceProvider.$get();
            menuService.getMenu().success(function (data) {
                angular.forEach(data, function (menu) {
                    $routeProvider.when(menu.Path, {
                        controller: menu.Controller,
                        templateUrl: AppUtils.createViewUrl(menu.TemplateUrl, globals)
                    });
                });
                $routeProvider.otherwise({
                    redirectTo: "/home"
                });
            }).error(function () {
                $window.alert("Could not get the menu");
            });
        }]);
})(app || (app = {}));
//# sourceMappingURL=app.js.map
