var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var app;
(function (app) {
    (function (contacts) {
        var ContactsController = (function (_super) {
            __extends(ContactsController, _super);
            function ContactsController(utilities, $scope, $location, contactsService) {
                _super.call(this, $scope);
                this.utilities = utilities;
                this.$scope = $scope;
                $scope.pageSize = 10;
                $scope.pageCount = 0;
                $scope.currentPage = 1;
                $scope.search = function (pageNumber, pageSize, name, eventToRaise) {
                    contactsService.getContacts({ PageNumber: pageNumber, PageSize: pageSize, Name: name }, function (result) {
                        $scope.contacts = result.Result;
                        $scope.pageCount = result.TotalPages;
                        $scope.totalFound = result.TotalRows;
                        $scope.currentPage = pageNumber;
                        $scope.$broadcast(eventToRaise);
                    });
                };

                $scope.search(1, $scope.pageSize, $scope.name, "searchCompleted");

                $scope.performSearch = function () {
                    $scope.search(1, $scope.pageSize, $scope.name, "searchCompleted");
                };
                $scope.gotoPage = function (pageNumber) {
                    $scope.search(pageNumber, $scope.pageSize, $scope.name, "pageLoadCompleted");
                };

                $scope.editContact = function (contact) {
                    $location.path("/contact/edit/" + contact.ContactId);
                };

                $scope.add = function () {
                    $location.path("/contact/edit/add");
                };

                var deleted = function (result) {
                    if (result) {
                        $scope.search($scope.currentPage, $scope.pageSize, $scope.name, "searchCompleted");
                    }
                };

                var deleteContact = function (contact) {
                    contactsService.deleteContact(contact, deleted);
                };

                $scope.deleteContact = function (contact) {
                    var buttons = [
                        {
                            mehtod: function () {
                                deleteContact(contact);
                            },
                            label: "Delete"
                        },
                        {
                            label: "Cancel"
                        }
                    ];
                    utilities.showMessage("Delete " + contact.LastName + ", " + contact.FirstName + "?", false, buttons);
                };
            }
            return ContactsController;
        })(app.core.controllers.CoreController);

        angular.module("app.contacts.contactsController", ["app.core.services.utilities", "app.contacts.services"]).controller("app.contacts.contactsController", [
            "utilities", "$scope", "$location", "contactsService",
            function (utilities, $scope, $location, contactsService) {
                return new ContactsController(utilities, $scope, $location, contactsService);
            }]);
    })(app.contacts || (app.contacts = {}));
    var contacts = app.contacts;
})(app || (app = {}));
//# sourceMappingURL=contactsController.js.map
